classification
Title: Using of simple dialogs without default root window
Type: enhancement Stage: resolved
Components: Tkinter Versions: Python 3.10
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: gpolo, serhiy.storchaka, terry.reedy
Priority: normal Keywords: patch

Created on 2020-12-22 20:35 by serhiy.storchaka, last changed 2020-12-25 19:43 by serhiy.storchaka. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 23897 merged serhiy.storchaka, 2020-12-22 20:55
Messages (3)
msg383612 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2020-12-22 20:35
Currently, standard message boxes in tkinter.messagebox (like showinfo() or askyesnocancel()) can be called without master or default root window. If arguments master or parent are not specified and there is no default root window is still created, the root window is created and set as the default root window. It is kept visible after closing a message box. It was done for testing from REPL. It affects also tkinter.colorchooser.askcolor().

The drawback is that the root window is kept visible and that it is set as the default root window (so following explicit calls of Tk(), with possible different arguments does not set the default root window).

Simple query dialogs in tkinter (like askinteger()) initially had the same behavior. But later it was broken, and currently they do not work if master and parent are not specified and the default root window is not set.

Proposed PR improves behavior of message boxes and colorchooser and restore the lost feature for query dialogs. Now if master and parent are not specified and the default root window is not set, the new temporary hidden root window is created, but is not set as the default root window. It will be destroyed right after closing the dialog, so it will not affect other widgets.
msg383666 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2020-12-24 02:38
The does not affect IDLE, as the two ask... calls pass parent.  (And I may someday replace them with query.Query subclasses.)  But I do prefer that tkinter act consistently and sensibly for others.  The PR's initial commit message adds this justification for the particular behavior: "It will help to use these simple dialog windows in programs which do
not need other GUI."  I agree with this goal.

Contrary to the message above, temporary root is set as _default_root and the latter is then set back to None.  Consequently, there can be no temporary if _default_root cannot be set.  Changing this would be messy enough that I think it reasonable to presume and require that people not otherwise needing a GUI will not call no_default_root, or learn to call Tk() if using an installation with patched tkinter.
msg383756 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2020-12-25 18:19
New changeset 675c97eb6c7c14c6a68ebf476c52931c1e5c1220 by Serhiy Storchaka in branch 'master':
bpo-42721: Improve using simple dialogs without root window (GH-23897)
https://github.com/python/cpython/commit/675c97eb6c7c14c6a68ebf476c52931c1e5c1220
History
Date User Action Args
2020-12-25 19:43:34serhiy.storchakasetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2020-12-25 18:19:27serhiy.storchakasetmessages: + msg383756
2020-12-24 02:39:00terry.reedysetnosy: + terry.reedy
messages: + msg383666
2020-12-22 20:55:05serhiy.storchakasetkeywords: + patch
stage: patch review
pull_requests: + pull_request22752
2020-12-22 20:35:40serhiy.storchakacreate